
unit Cybmanip;
{string manipulation routines}
interface
 uses SysUtils, Windows, Messages, Classes, Graphics, Controls,
       Consts, ShlObj, ActiveX, shellapi,printers, dialogs, forms{, Cybifile};

{const

  mymaxint = 65000;}

type

{ tbytearray = array[0..mymaxint] of byte;
 pbytearray = ^tbytearray;}

  Tbyte4_array = array[0..3] of byte;
  tbyte2_array = array[0..1] of byte;

    tfloat = double;
    tstrclass = class
        astr : string;
    end;
    tintclass = class
        aint : integer;
    end;

    str1 = string[1];
    str2 = string[2];
    str3 = string[3];
    str4 = string[4];
    str5 = string[5];
    str6 = string[6];
    str7 = string[7];
    str8 = string[8];
    str10 = string[10];
    str12 = string[12];
    str13 = string[13];
    str15 = string[15];
    str18 = string[18];
    str20 = string[20];
    str25 = string[25];
    str26 = string[26];
    str30 = string[30];
    str35 = string[35];
    str40 = string[40];
    str44 = string[44];
    str45 = string[45];
    str50 = string[50];
    str60 = string[60];
    str65 = string[65];
    str70 = string[70];
    str73 = string[73];
    str78 = string[78];
    str75 = string[75];
    str80 = string[80];
  min_date = array[1..3] of byte;

function null_test(instr : string) : boolean;
function comment_test(instr : string) : boolean;
function word_hex(w : word) : str4;
function byte_hex( b : byte) : str2;
function long_hex(l : longint) : string;

function erase_white(strng : string) : string;
function greatint(t1,t2 : longint) : longint;
function lessint(t1,t2 : longint) : longint;
function remove_char(ch : char; strng : string) : string;
function remove_disallowedchars(strng : string) : string;
function remove_ms(astr : string) : string;

function split_caps(strng : string) : string;
function booltostr( val : boolean) : string;
function YNboolstr( val : boolean) : string;
function TFboolstr( val : boolean) : string;

function CentreString(strng : string; width : byte) : string;
function rpt (strng : string; rp : byte) : string;
function makeunique(olds : string) : string;
function indent( indentlevel : integer) : string;
function StripBracketNo(var olds : string) : integer;
function StripBracketString(var olds : string) : String;

function StripBracketsAndSemis(olds : string) : String;


function bytetohash(inpstr : string) : string;
function hashtobyte(inpstr : string) : string;

function HasStringin(srchstr, astr : string) : boolean;
function Stringin(srchstr : string; var astr : string) : boolean;
function ReplaceString(srchstr, repstr, astr : string) : string;
function ReplaceStringNoCase(srchstr, repstr, astr : string) : string;
function ReplaceAllOcurrences(srchstr, repstr, astr : string) : string;

procedure Split_line(line : string; splitchar : char; aplist : tstrings);
procedure Split_lineStr(line : string; splitstr : string; aplist : tstrings);
procedure Split_lineSpaces(line : string; aplist : tstrings);

function remext(nme : string) : string;
function timereal_2str(z : tfloat) : string;
function erase_white_end(strng : string) : string;
function erase_white_begin(strng : string) : string;
function LJ(strng : string;
            wdth : byte) : string;
function fixordno(os : string) : string;
function RJ(strng : string;
            wdth : byte) : string;
function properstring(strng : string) : string;
function get_nums(strng : string) : string;
function strip_nums(var strng : string) : string;

function extreal(re : tfloat) : string;
function realstr(z : tfloat) : string;
function str_real(st : string) : tfloat;

function cal_julian(datevar : min_date) : tfloat;
procedure julian_cal(jdn : tfloat; var t_d : min_date);
function check_date(date : min_date) : boolean;
function encode_date(dte : str10) : str3;
function decode_date(dum : min_date) : str10;
procedure adddate(date : min_date; days : tfloat; var sum : min_date);
function futuredate( entdate : min_date) : boolean;
procedure unlink_date(date : str10; var dte : min_date);

procedure draw_rotated_text(     acanvas : tcanvas;
                                 angle : tfloat;
                                 posn : tpoint;
                                 msg : string);
Procedure mywinexec(progname : string; SHOWMODE : integer);
function ExecuteFile(const FileName, Params, DefaultDir: string;
  ShowCmd: Integer): THandle;
function MySelectDirectory(Caption, Root: string; var Directory: string): Boolean;

procedure checklist(astring : string; aplist:  tstrings);
PROCEDURE deleteItemfromlist(astring : string; aplist:  tstrings);
{procedure readstrlist(inifile : tinifile; aplist:  tstrings; Sectname : string);
procedure writestrlist(inifile : tinifile; aplist:  tstrings; Sectname : string);}
procedure insertbefore(aplist : tstrings; markeritem, newitem : string);
procedure deleteEmptyfromlist(dellist : tstrings);
PROCEDURE deletefromlist(dellist, inlist : tstrings);

function datestrtoYankdatestr( astr : string) : string;

procedure print_metrics;
procedure newline;
procedure pbig(pos : integer; strng : string);
procedure printR(pos,field : integer; strng : string);
procedure printL(pos,field : integer; strng : string);

function Str2Object(anystr : string) : tobject;
function Object2Str(anystrobj : tobject) : string;
procedure FreeObjectStr(anystrobj : tobject);

function Int2Object(anyint : longint) : tobject;
function Object2Int(anyintobj : tobject) : longint;
procedure FreeObjectInt(anyintobj : tobject);

{$IFnDEF WIN32}
procedure SetLength(var S: String; NewLength: Integer);
{$ENDIF}

function addDelphidate(adate : tdatetime; days : tfloat) : tdatetime;
function daysapart(bdate, edate : tdatetime) : tfloat;

function MakeHexWord(w: Word): string;
function HexStr2Byte(s: string): byte;
function hourstring2hour (instr : string) : tfloat;


function b_to_n(b : byte; which : char) : byte;
function nib_to_char(b : byte) : char;

function StandardPassword2bytearray(apassword : string) : Tbyte4_array;

function BCDtoLongint( arraylength : integer;  abytearray : Pbytearray; var aval : longint) :boolean;
function LongintToBCD( inno : longint; arraylength : integer;  abytearray : Pbytearray) : boolean;
function LongintToExpBCD( inno : longint; arraylength : integer;  abytearray : Pbytearray) : boolean;
procedure fillbytearraywithchars (fillchr : char; arraylength : integer;  abytearray : Pbytearray);
procedure date2bytearray (indate : tdatetime; arraylength : integer;  abytearray : Pbytearray; addslash : boolean);
function Bytearray2String (arraylength : integer;  abytearray : Pbytearray) : string;
procedure String2bytearray (instring : string; arraylength : integer;  abytearray : Pbytearray);

function CalculateCRC(InString : pbytearray; inLength : BYTE ) : byte;

function AddBackSlash(const S: String): String;

function extractdate(dte : string) : tdatetime;


const
  begc : char ='(';
  endc : char =')';
  hash = '#';
  nought = 0;
  crlf = #13#10;

var
 yearoffset : word;
 today : str10;
 linecounter : longint;
 lineheight,charwidth : integer;

implementation

{$IFnDEF WIN32}
{ for Delphi 1.0 16 bit projects }
procedure SetLength(var S: String; NewLength: Integer);
begin
S[0] := Char(NewLength);
end;
{$ENDIF}

function AddBackSlash(const S: String): String;
{ Adds a backslash to string S.  If S is already 255 chars or already has }
{ trailing backslash, then function returns S. }
begin
  if (Length(S) < 255) and (S[Length(S)] <> '\') then
    Result := S + '\'
  else
    Result := S;
end;

function remove_ms(astr : string) : string;

begin
   result := erase_white(astr);
   result := remove_char('M', result);
   result := remove_char('m', result);
end;

function CalculateCRC(InString : pbytearray; inLength : BYTE ) : byte;
{Calculate CRC digit for commands to Reader}
Var
   lc : integer;

begin
   result := 0;
   for lc := 0 to pred(inLength) do result := result XOR InString^[lc];
end;

function BCDtoLongint( arraylength : integer;  abytearray : Pbytearray; var aval : longint) :boolean;
Var
   lc, mc : integer;
   tstr : string;

begin
   mc := pred(arraylength);
   tstr := '';
   for lc := 0 to mc do begin
     tstr := tstr + byte_hex( abytearray^[lc]);
   end;
try
   aval := strtoint(tstr);
   result := true;
except
  aval := -1;
  result := false;
end;
end;

function LongintToExpBCD( inno : longint; arraylength : integer;  abytearray : Pbytearray) : boolean;
Var
   ml,lc, mc : integer;
   tstr : string;
   lb : byte;

begin
   result := false;
   tstr := inttostr(inno);
   mc := length(tstr);
   if (mc > arraylength) then exit;
   ml := pred(arraylength);
   for lc := 0 to ml   do begin
     if ((mc-lc) > 0) then lb := strtoint(tstr[mc-lc])
                    else lb := 0;
     abytearray^[ml - lc] := lb;
   end;
end;

function LongintToBCD( inno : longint; arraylength : integer;  abytearray : Pbytearray) : boolean;
Var
   ml,lc, mc : integer;
   tstr : string;
   lb, hb,lbi, hbi : byte;
   tst1,tst2 : shortint;

begin
   result := false;
   tstr := inttostr(inno);
   mc := length(tstr);
   if (mc > (arraylength*2)) then exit;
   ml := pred(arraylength);
   for lc := 0 to ml do begin
     tst1 := (mc-(2*lc));
     tst2 := (mc-((2*lc)+1));
     if (tst2 > 0) then hbi := strtoint(tstr[tst2])
                   else hbi := 0;
     if (tst1 > 0) then lbi := strtoint(tstr[tst1])
                   else lbi := 0;
     hb := (hbi shl 4);
     lb := hb + lbi;
     abytearray^[ml-lc] := lb;
   end;
end;

function Bytearray2String (arraylength : integer;  abytearray : Pbytearray) : string;
Var
   lc, mc : integer;

begin
   result := '';
   for lc := 0 to arraylength do begin
     if (abytearray^[lc] <> 0) then result := result + char(abytearray^[lc]);
   end;
end;


procedure String2bytearray (instring : string; arraylength : integer;  abytearray : Pbytearray);
Var
   lc, mc : integer;

begin
   mc := length(instring);
   if (mc > arraylength) then exit;
   dec(mc);
   for lc := 0 to mc do begin
     abytearray^[lc] := ord(instring[succ(lc)]);
   end;
end;

procedure date2bytearray (indate : tdatetime; arraylength : integer;  abytearray : Pbytearray; addslash : boolean);
Var
   Yr, Mo, Dy: Word;
   instring : string;

begin
   DecodeDate(inDate, Yr, Mo, Dy);
   if addslash then instring := inttostr(Mo)+'/'+ inttostr(Yr)
               else instring := inttostr(Mo)+ inttostr(Yr);
   String2bytearray (instring, arraylength, abytearray);
end;

procedure fillbytearraywithchars (fillchr : char; arraylength : integer;  abytearray : Pbytearray);

Var
   lc, mc : integer;

begin
   mc := pred(arraylength);
   for lc := 0 to mc do begin
     abytearray^[lc] := ord(fillchr);
   end;
end;

function StandardPassword2bytearray(apassword : string) : Tbyte4_array;
Var
   lc, mc : integer;
   ab1, ab2 : byte;

begin
   mc := pred(length(apassword) div 2);
   for lc := 0 to mc do begin
       ab1 := b_to_n(byte(apassword[2*lc+1]),'L');
       ab2 := b_to_n(byte(apassword[2*lc+2]),'L');
       result[lc] := ab2 + (ab1 shl 4);
   end;
end;

function datestrtoYankdatestr( astr : string) : string;
var
  yr,mo,dy : word;

begin
   decodedate(strtodatetime(astr), yr,mo,dy);
   result := inttostr(mo)+'/'+inttostr(dy)+'/'+inttostr(yr);
end;

function hourstring2hour (instr : string) : tfloat;
var
  hpos : byte;
  hrstr, minstr : string;

begin
   hpos := pos('h',instr);
   hrstr := copy(instr,1,pred(hpos));
   minstr := copy(instr,succ(hpos),length(instr)-hpos);
   result := strtoint(hrstr)+(strtoint(minstr)/60);
end;

function TFboolstr( val : boolean) : string;

begin
    if val then result := 'T'
           else result := 'F';
end;

function daysapart(bdate, edate : tdatetime) : tfloat;

var
  dum1, dum2 : tfloat;

begin
 dum1 := tfloat(bdate);
 dum1 := trunc(dum1);
 dum2 := tfloat(edate);
 dum2 := trunc(dum2);
 result := dum2-dum1;
end;

function addDelphidate(adate : tdatetime; days : tfloat) : tdatetime;

var
{  yr,mo,dy : word;
  tyrs,yrs,mos,dys : word; }

  dum1, dum2 : tfloat;

begin
 dum1 := tfloat(adate);
 dum1 := trunc(dum1);
 dum2 := frac(dum1);
 dum1 := dum1+days;
 dum2 := dum1+dum2;
 result := tdatetime(dum2);
end;

function get_nums(strng : string) : string;

Var
   lc, mc : integer;

begin
    result := '';
    mc := length(strng);
    for lc := 1 to mc do begin
      if (strng[lc] in ['.','+','-','0'..'9']) then begin
        result := result+strng[lc];
      end;
    end;
end;

function strip_nums(var strng : string) : string;

var
 lc, mc : integer;

begin
    result := '';
    mc := length(strng);
    for lc := 1 to mc do begin
      if (strng[lc] in ['+','-','0'..'9']) then begin
        result := result+strng[lc];
        strng[lc] := ' ';
      end;
    end;
    strng := erase_white(strng);
end;


function Int2Object(anyint : longint) : tobject;
begin
   result := tintclass.create;
   with tintclass(result) do aint := anyint;
end;

function Object2Int(anyintobj : tobject) : longint;
begin
      with (anyintobj as tintclass) do result := aint;
end;

procedure FreeObjectInt(anyintobj : tobject);
begin
   with (anyintobj as tintclass) do free;
end;


function Str2Object(anystr : string) : tobject;

begin
   result := tstrclass.create;
   with tstrclass(result) do astr := anystr;
end;

function Object2Str(anystrobj : tobject) : string;
begin
      with (anystrobj as tstrclass) do result := astr;
end;

procedure FreeObjectStr(anystrobj : tobject);
begin
   with (anystrobj as tstrclass) do free;
end;

PROCEDURE deletefromlist(dellist, inlist : tstrings);
Var
   pc, lc, mc : integer;

begin
   mc := pred(dellist.count);
   for lc := 0 to mc do begin
       pc := inlist.indexof(dellist[lc]);
       if (pc <> -1) then inlist.delete(pc);
   end;
end;

PROCEDURE deleteEmptyfromlist(dellist : tstrings);
var
  lc,mc : integer;
  tmpstr : string;

begin
  lc := 0;
  mc := pred(dellist.count);
  while (lc <= mc) do begin
      tmpstr := dellist[lc];
      if not(null_test(tmpstr)) then begin
         inc(lc);
      end
      else begin
           dellist.delete(lc);
           mc := pred(dellist.count);
      end;
  end;
end;


procedure insertbefore(aplist : tstrings; markeritem, newitem : string);
Var
   lc : integer;

begin
  lc := aplist.indexof(markeritem);
  if (lc > -1) then  aplist.insert(lc, newitem);
end;

function RJ(strng : string;
            wdth : byte) : string;
var
  sl : integer;

begin
  if (strng[1] = ' ') then strng := erase_white_begin(strng);
  sl := length(strng);
  if (wdth < sl) then result := copy(strng,1,wdth)
                 else result := concat(rpt('0',wdth-sl),strng);
end;

function fixordno(os : string) : string;

begin
    result := rj(os, 6);
end;

function erase_white_begin(strng : string) : string;

Var
   lc2, lc, mc : integer;

begin
   result := '';
   mc := length(strng);
   if mc = 0 then exit;
   lc := 1;
   while (((strng[lc] = #32) or (strng[lc] = #9))  and (lc <= mc)) do inc(lc);
   for lc2 := lc to mc do result := result + strng[lc2];
{   result := copy(strng,lc,succ(mc-lc));}
end;

function LJ(strng : string;
            wdth : byte) : string;

begin
  if (strng[1] = ' ') then strng := erase_white_begin(strng);
  if (wdth < length(strng)) then result := copy(strng,1,wdth)
                          else result := concat(strng,rpt(' ',wdth-length(strng)));
end;


function erase_white_end(strng : string) : string;

var
 x,i : integer;

begin
 x := length(strng);
 i := x;
 while ((not (strng[i] in [#33 .. #127])) and (i >= 1)) do dec(i);
 setlength(strng,i);
 erase_white_end := strng;
end;


function timereal_2str(z : tfloat) : string;

var
 hri, mini : longint;

begin
  hri := trunc(z / 3600);
  mini :=  round((z -(hri*3600))/ 60);
  if (hri > 0) then begin
    if (hri > 1) then result := inttostr(hri)+' Hrs '+inttostr(mini)+' Mins'
                 else  result := inttostr(hri)+' Hr '+inttostr(mini)+' Mins';
  end
  else result := inttostr(mini)+' Mins';
end;


function remext(nme : string) : string;

var
  dpo : byte;

begin
  dpo := pos('.',nme);
  if (dpo <> nought) then result := copy(nme,1,pred(dpo))
                     else result := nme;
end;

function comment_test(instr : string) : boolean;
begin
{    result := (instr[1] = ';');}
    result := (pos(';',instr) = 1);
end;

function null_test(instr : string) : boolean;

begin
    result := (instr = ' ') or (instr = '');
end;

procedure printL(pos,field : integer; strng : string);

begin
  printer.canvas.textout( pos*charwidth, linecounter*lineheight,concat(strng,rpt(' ',field - length(strng))));
end;

procedure printR(pos,field : integer; strng : string);

begin
 printer.canvas.textout(pos*charwidth, linecounter*lineheight, concat(rpt(' ',field - length(strng)),strng));
end;

procedure pbig(pos : integer; strng : string);

begin
 printer.canvas.font.size := 2 * printer.canvas.font.size;
 printer.canvas.textout(pos*charwidth, pred(linecounter)*lineheight, strng);
 printer.canvas.font.size :=  printer.canvas.font.size div 2;
end;

procedure newline;

begin
  inc(linecounter);
end;

procedure print_metrics;

begin
      lineheight := printer.canvas.TEXTheight('M');
      charwidth := printer.canvas.textwidth('M');
{      lm := leftmargin * cwidth;
      lh := (round(line_spacing * lineheight));
      linesperpage := printer.pageheight div lh - (2*first_line);
      line_countr := first_line;
      maxwidth := maxprintwidth * cwidth;
      maxpwidth := printer.pagewidth;}
end;

(*
procedure readstrlist(inifile : tinifile; aplist:  tstrings; Sectname : string);
begin
    aplist.clear;
    inifile.readsection(Sectname, aplist);
end;

procedure writestrlist(inifile : tinifile; aplist:  tstrings; Sectname : string);
{var
  lc, mc : integer;
 }
begin
    inifile.exchangesection(Sectname, aplist);
{    for lc := 0 to mc do inifile.WriteString(Sectname,aplist[lc], '');}
end;
*)
PROCEDURE deleteItemfromlist(astring : string; aplist:  tstrings);
Var
   lc : integer;

begin
   if (astring = '') then exit;
   lc := aplist.indexof(astring);
   if (lc <> -1) then aplist.delete(lc);
end;


procedure checklist(astring : string; aplist:  tstrings);
Var
   lc : integer;

begin
   if (astring = '') then exit;
   lc := aplist.indexof(astring);
   if (lc = -1) then aplist.add(astring);
end;

procedure Split_lineSpaces(line : string; aplist : tstrings);
var
  dstr : string;
   lc, mc : integer;

begin
   mc := length(line)+1;
   aplist.clear;
   lc := 1;
   dstr := '';
   while (lc < mc)  do begin
       if not(line[lc] in [#9, #32]) then begin
         dstr := dstr + line[lc];
         inc(lc);
       end
       else begin
         if (dstr <> '') then aplist.add(dstr);
         dstr := '';
         while (lc < mc) and (line[lc] in [#9, #32]) do inc(lc);
       end;
   end;
   if (dstr <> '') then aplist.add(dstr);
end;

procedure Split_lineStr(line : string; splitstr : string; aplist : tstrings);
var
  lstr,tpos : INTEGER;
  dstr : string;

begin
   lstr := length(splitstr);
   tpos := pos(splitstr,line);
   aplist.clear;
   while (tpos <> 0)  do begin
       dstr := copy(line,1,pred(tpos));
       aplist.add(dstr);
       delete(line,1,tpos+pred(lstr));
       tpos := pos(splitstr,line);
   end;
   aplist.add(line);
end;

procedure Split_line(line : string; splitchar : char; aplist : tstrings);

var
  tpos : byte;
  dstr : string;

begin
   tpos := pos(splitchar,line);
   aplist.clear;
   while (tpos <> 0) do begin
{       if (tpos = 0) then tpos := length(line);}
       dstr := copy(line,1,pred(tpos));
       aplist.add(dstr);
       delete(line,1,tpos);
       tpos := pos(splitchar,line);
   end;
   aplist.add(line);
end;

function ReplaceAllOcurrences(srchstr, repstr, astr : string) : string;

begin
   result := astr;
   while (pos(srchstr, result) <> 0) do result := ReplaceString(srchstr, repstr, result);
end;

function ReplaceString(srchstr, repstr, astr : string) : string;
Var
   sc, lc, mc : integer;
   t1,t2 : string;

begin
    result := astr;
    sc := pos(srchstr, astr);
    if (sc = 0) then exit;
    mc := length(srchstr);
    lc := length(astr);
    t1 := copy(astr,1, pred(sc));
    t2 := copy(astr,sc+mc,succ(lc-mc-sc));
    result := t1+repstr+t2;
end;

function ReplaceStringNoCase(srchstr, repstr, astr : string) : string;
Var
   sc, lc, mc : integer;
   t1,t2 : string;

begin
    result := astr;
    sc := pos(uppercase(srchstr), uppercase(astr));
    if (sc = 0) then exit;
    mc := length(srchstr);
    lc := length(astr);
    t1 := copy(astr,1, pred(sc));
    t2 := copy(astr,sc+mc,succ(lc-mc-sc));
    result := t1+repstr+t2;
end;

function HasStringin(srchstr, astr : string) : boolean;
Var
   sc : integer;

begin
    sc := pos(srchstr, astr);
    result := (sc <> 0);
end;


function Stringin(srchstr : string; var astr : string) : boolean;

Var
   sc, lc, mc : integer;
   t1,t2 : string;

begin
{    result := false;}
    sc := pos(srchstr, astr);
    result := (sc <> 0);
    if not(result) then exit;
    mc := length(srchstr);
    lc := length(astr);
{    for lc := 1 to mc do astr := remove_char(srchstr[lc], astr);}
    t1 := copy(astr,1, pred(sc));
    t2 := copy(astr,sc+mc,succ(lc-mc-sc));
    astr := t1+t2;
end;


function hashtobyte(inpstr : string) : string;

var
  tv : byte;
  lc2,lc,mc,hpos : integer;
  tstr2,tstr : string;

begin
    mc := length(inpstr);
    lc := nought;
    result := '';
    tstr2 := inpstr;
    repeat
       hpos := pos(hash, tstr2);
       if hpos = nought then begin
         result := result+tstr2;
         exit;
       end;
       lc2 := succ(hpos);
       tstr := '';
       while ((tstr2[lc2] >= '0') and (tstr2[lc2] <= '9')) do begin
           tstr := tstr+tstr2[lc2];
           inc(lc2);
       end;
       tv := strtoint(tstr);
       result := result+copy(tstr2,1,hpos)+char(tv);
       lc := lc+hpos+lc2;
       tstr2 := copy(inpstr,lc,(mc-lc));
    until (lc >= mc)
end;

function bytetohash(inpstr : string) : string;
var
  lc3,lc2,lc,mc : integer;
  tstr : string;
  lb : boolean;

begin
    mc := length(inpstr);
    lc := nought;
    result := '';
    while (lc <= mc) do begin
       lb := ((inpstr[lc] <' ') or (inpstr[lc] <' '));
       if lb then begin
          result[lc] := hash;
          tstr := inttostr(ord(inpstr[lc]));
          lc2 := length(tstr);
          for lc3 := 1 to lc2 do result[lc+lc3] := tstr[lc3];
          mc := mc+lc2;
       end
       else begin
          result[lc] := inpstr[lc];
       end;
       inc(lc);
    end;
    setlength(result,mc);

{    result[0] := char(mc);}
end;

function b_to_n(b : byte; which : char) : byte;

begin
  if which = 'H' then result := b div 16
     		 else result := b mod 16;
end;

function n_to_b(b : byte; which : char) : byte;

begin
  if which = 'H' then result := b div 16
     		 else result := b mod 16;
end;


function nib_to_char(b : byte) : char;

begin
   if b < 10 then result := chr(ord(b+48))
             else result := chr(ord(b+55));
end;

const
  hexChars: array [0..$F] of Char ='0123456789ABCDEF';

function MakeHexWord(w: Word): string;

begin
  Result := hexChars[Hi(w) shr 4];
  Result := Result + hexChars[Hi(w) and $F];
  Result := Result + hexChars[Lo(w) shr 4];
  Result := Result + hexChars[Lo(w) and $F];
end;

function HexStr2Byte(s: string): byte;
begin
{  Result := '';}
   s := uppercase(s);
  Result := pred(pos(s[1],hexChars)) shl 4;
  Result := Result + pred(pos(s[2],hexChars));
end;


function word_hex(w : word) : str4;

begin
 result[1] := nib_to_char(b_to_n(hi(w),'H'));
 result[2] := nib_to_char(b_to_n(hi(w),'L'));
 result[3] := nib_to_char(b_to_n(lo(w),'H'));
 result[4] := nib_to_char(b_to_n(lo(w),'L'));
{ result[0] := chr(4);}
  setlength(result, 4);
end;
function long_hex(l : longint) : string;

begin
   result := word_hex(longrec(l).hi)+word_hex(longrec(l).lo);
end;

function byte_hex(b : byte) : str2;

begin
 result[1] := nib_to_char(b_to_n(b,'H'));
 result[2] := nib_to_char(b_to_n(b,'L'));
{ result[0] := chr(2);}
  setlength(result, 2);
end;


function StripBracketsAndSemis(olds : string) : String;

begin
{   result := erase_white(olds);}
   result := remove_char(begc, olds);
   result := remove_char(endc, result);
   result := remove_char(';', result);
end;

function StripBracketNo(var olds : string) : integer;

var
   mc : integer;
  nstr : string;

begin
  result := pos(begc,olds);
  if (result = nought) then exit;
  mc := pos(endc,olds);
  nstr := copy(olds, succ(result), pred(mc-result));
  olds := copy(olds, 1, pred(result));
  result := strtoint(erase_white(nstr));
end;

function StripBracketString(var olds : string) : String;

var
   tc, lc, mc : integer;
  nstr : string;

begin
  tc := pos(begc,olds);
  if (tc = nought) then exit;
  lc := length(olds);
  mc := pos(endc,olds);
  nstr := copy(olds, succ(tc), pred(mc-tc));
  olds := copy(olds, 1, pred(tc))+copy(olds, succ(mc), (lc-mc+1));
  result := erase_white(nstr);
end;

function indent( indentlevel : integer) : string;
begin
  result := rpt('  ', indentlevel);
end;

function makeunique(olds : string) : string;
var
  endc, endc2 : char;
  lc : integer;
begin
  lc := (length(olds));
  if lc = 0 then begin
    result := 'A';
    exit;
  end;
  result := '';
  endc := olds[lc];
  if (endc >= '0') and (endc <= '8') then olds[lc] := char(succ(ord(endc)))
  else begin
     if (endc < '0') or (endc > '9') then olds := olds+'0'
     else if (endc = '9') then begin
         endc2 := olds[pred(lc)];
         if (endc2 >= '0') and (endc2 <= '9') then begin
            olds[pred(lc)] := char(succ(ord(endc2)));
            olds[lc] := '0';
         end
         else olds := olds+'10';
     end;
  end;
  result := olds;
end;

function rpt (strng : string; rp : byte) : string;

var
  i : byte;

begin
  result := '';
  if (rp > 0) then begin
     if (length(strng) = 1) then begin
       setlength(result,rp);
       fillchar(result[1],rp,ord(strng[1]));
{       result[0] := chr(rp);}
     end
     else if (length(strng) <> 0) then for i := 1 to rp do result := concat(result,strng);
  end;
end;

function CentreString(strng : string; width : byte) : string;
var
  s1,s2,plen : word;

begin
  if (strng <> '') then begin
    plen := length(strng);
    IF (plen > width) then begin
      strng := copy(strng,1,width);
{      result := strng+'|';}
    end
    else begin
         s1 := (width - plen) div 2;
         s2 := (width - plen) mod 2;
         result := concat(rpt(' ',s1+s2),strng,rpt(' ',s1){,'|'});
    end;
  end
  else result := rpt(' ',width){+'|'};
end;

function YNboolstr( val : boolean) : string;

begin
    if val then result := 'Y'
           else result := 'N';
end;

function booltostr( val : boolean) : string;

begin
    if val then result := 'True'
           else result := 'False';
end;

function greatint(t1,t2 : longint) : longint;
begin
    if (t1 < t2) then result := t2
                 else result := t1;
end;

function lessint(t1,t2 : longint) : longint;
begin
    if (t1 > t2) then result := t2
                 else result := t1;
end;

function erase_white(strng : string) : string;

begin
    result := remove_char(' ',strng);
    result := remove_char(#9,result);
end;

function ProperString(strng : string) : string;
var
 cs, cm, c1 : integer;
 ts : string;

begin
   result := strng;
   strng := lowercase(strng);
   cm := length(strng);
   if cm < 1 then exit;
   ts := strng[1];
   ts := uppercase(ts);
   strng[1] := ts[1];
   for c1 := 1 to cm do if ((strng[c1] = ' ') or (strng[c1] = '(') or (strng[c1] = '/')) then begin
        cs := c1+1;
        if cs > cm then break;
        ts := strng[cs];
        ts := uppercase(ts);
        strng[cs] := ts[1];
   end;
   result := strng;
end;

function remove_disallowedchars(strng : string) : string;
Var
   lc, mc : integer;
   ab : byte;
   ltr, undr, num : boolean;

begin
{The following restrictions apply to identifier names:

Identifiers can be of any length, but only the first 63 characters are significant.
	The first character of an identifier must be a letter or an underscore (_).
	The characters that follow the first one must be letters, digits, or underscores.
	No spaces are allowed in an identifier.}
   mc := length(strng);
   strng := ProperString(strng);
   result := '';
   for lc := 1 to mc do begin
     ab := byte(strng[lc]);
     ltr :=  ((ab > 96) and ( ab < 123)) or ((ab > 64) and ( ab < 91));
     undr := (ab = 95);
     num := ((ab > 47) and ( ab < 58));
     if length(result) = 0 then begin
        if (ltr or undr) then result := result + strng[lc];
     end
     else if (ltr or undr or num) then result := result + strng[lc];
     if length(result) > 62 then exit;
   end;
end;


function remove_char(ch : char; strng : string) : string;

var
 mc, lc : integer;

begin
    mc := length(strng);
    result := '';
    for lc := 1 to mc do if (strng[lc] <> ch) then result := result + strng[lc];
end;

function split_caps(strng : string) : string;

var
 cm, c1 : integer;


begin
    cm := length(strng);
    c1 := 1;
    while (c1 < cm) do begin
      if ((c1 >1) and (strng[c1] >= 'A') and (strng[c1] <= 'Z')) then begin
        insert(' ', strng, c1);
        inc(cm);
        inc(c1);
      end;
      inc(c1);
    end;
    result := strng;
end;

procedure adddate(date : min_date; days : tfloat; var sum : min_date);

var
  CybNow : tfloat;

begin
    CybNow := cal_julian(date);
    julian_cal((CybNow + days),sum);
end;

function futuredate( entdate : min_date) : boolean;
var
  to_min : min_date;
begin
  unlink_date(today,to_min);
  if ( cal_julian(entdate) >= cal_julian(to_min) ) then futuredate := true
                                                  else futuredate := false;
end;

function cal_julian(datevar : min_date) : tfloat;

var
{  ecode : integer;}
  month,year,day,y1{,pv} : tfloat;

begin
    year := datevar[1] * 1.0;
    month := datevar[2] * 1.0;
    day :=  datevar[3] * 1.0;
{    pv := 7.5 /12;}
    year := year + yearoffset;
    y1 := year + (month - 2.85) / 12;
    cal_julian := int( int( int(367.0 * y1) - int(y1) - 0.75 * INT(Y1) + day)
                  - 0.75 * 2.0) + 1721115.0;
end;

procedure julian_cal(jdn : tfloat; var t_d : min_date);

var
  n1,n2,y1,m1 : tfloat;
  fix : longint;

begin
  n1 := (jdn - 1721119.0) + 2.0;
  y1 := int((n1 - 0.2) / 365.25);
  n2 := n1 - int(365.25 * y1);
  m1 := int((n2 - 0.5) / 30.6);
  t_d[3] := trunc(n2 - 30.6 * m1 + 0.5);
  fix := (trunc(y1 + ord(m1 > 9)));
  if fix < (yearoffset + 255) then t_d[1] := fix-yearoffset
                              else t_d[1] := 255;
  t_d[2] := trunc(m1 + 3 -(ord(m1 > 9) * 12));
end;

function check_date(date : min_date) : boolean;

const
  md : array[1..12] of integer
     = (31,28,31,30,31,30,31,31,30,31,30,31);
var
  decred : boolean;

begin
  if (date[1] > 99) then begin
    dec(date[1],100);
    decred := true;
  end
  else decred := false;
  if ((date[2] = 2) and ((date[1] mod 4 = 0) or (date[1] = 0))) then md[2] := 29
                                                        else md[2] := 28;
  if ((date[2] >= 1) and (date[2] <= 12)) then
    check_date := ((date[3] >= 1) and (date[3] <= md[date[2]]) and (date[1] >= 0) and (date[1] <= 99))
  else check_date := false;
  if decred then inc(date[1],100);
end;

procedure unlink_date(date : str10; var dte : min_date);

var
  temp_date : str3;

begin
    temp_date := encode_date(date);
    dte[1] := byte(temp_date[1]);
    dte[2] := byte(temp_date[2]);
    dte[3] := byte(temp_date[3]);
end;

function encode_date(dte : str10) : str3;

var
  ecode : integer;
  dum : array[0..3] of byte;
  lc,sl_1 : byte;
  cent : str2;
  centadd : boolean;

begin
  for lc := 1 to 2 do begin
   sl_1 := pos('/',dte);
   if (sl_1 = 0) then dum[4-lc] := 0
   else begin
     val(copy(dte,1,pred(sl_1)),dum[4-lc],ecode);
     if (ecode <> 0) then dum[4-lc] := 0;
     delete(dte,1,sl_1);
    end;
  end;
  sl_1 := length(dte);
  if (sl_1 = 4) then begin
    cent := copy(dte,1,2);
    centadd := false;
    if (cent = '20') then centadd := true;
    delete(dte,1,2);
    sl_1 := 2;
  end
  else centadd := (yearoffset = 2000) ;
  if ((sl_1 = 0) or (sl_1 > 2)) then dum[1] := 100
  else begin
    val(copy(dte,1,sl_1),dum[1],ecode);
    if (ecode <> 0) then dum[1] := 100;
    if (centadd) then inc(dum[1],100);
  end;
  dum[0] := 3;
  encode_date := str3(dum);
end;

function decode_date(dum : min_date) : str10;

var
 cen,yr,mo,day : str2;

begin
  if ((yearoffset = 2000) and (dum[1] = 0)) then cen := '20'
  else if (dum[1] < 100) then cen := '19'
			 else if dum[1] < 200 then cen := '20'
					      else cen := '21';
  if (dum[1] > 99) then dec(dum[1],100);
  str(dum[1],yr);
  if (length(yr) < 2) then yr := concat('0',yr);
  str(dum[2],mo);
  if (length(mo) < 2) then mo := concat('0',mo);
  str(dum[3],day);
  if (length(day) < 2) then day := concat('0',day);
  decode_date := concat(day,'/',mo,'/',cen,yr);
end;

procedure set_today;
var
 yr,mo,day : word;
 mymin : min_date;
 present : tdatetime;
 dstr : string;

begin
  present := now;
  decodedate(present,yr,mo,day);
  dstr := datetostr(present);
  mymin[1] := yr-yearoffset;
  mymin[2] := mo;
  mymin[3] := day;
  today := decode_date(mymin);
end;

procedure draw_rotated_text(     acanvas : tcanvas;
                                 angle : tfloat;
                                 posn : tpoint;
                                 msg : string);
var
  LogFont: TLogFont;
  oldfont : tfont;
  escm : integer;

begin
  oldfont := tfont.create;
  oldfont.assign(acanvas.font);
  with aCanvas do begin
    with LogFont do begin
      lfHeight := Font.Height;                { Set to Printer.Canvas.font.height }
      lfWidth := 0;                           { let font mapper choose width}
      escm := trunc(angle)*10;
      lfEscapement :=  escm;                   { tenths of degrees so 900 = 90 degrees }
      lfOrientation := 0;                     { ignored by Windows }
      lfWeight := FW_NORMAL;                  { default }
      lfItalic := 0;                          { no italics }
      lfUnderline := 0;                       { no underline }
      lfStrikeOut := 0;                       { no strikeout }
      lfCharSet := ANSI_CHARSET;              { default }
      StrPCopy(lfFaceName, Font.Name);        { Printer.Canvas's font's name }
      lfQuality := PROOF_QUALITY;             { Windows gets a better one if avail  }
      lfOutPrecision := OUT_TT_ONLY_PRECIS;   { force True type fonts }
      lfClipPrecision := CLIP_DEFAULT_PRECIS; { default }
      lfPitchAndFamily := Variable_Pitch;     { default }
    end;
  end;
  with aCanvas do begin
    Font.Handle := CreateFontIndirect(LogFont);
    textout(posn.x, posn.y, msg);
    font.assign(oldfont);
  end;
  oldfont.free;
end;

function ExecuteFile(const FileName, Params, DefaultDir: string;
  ShowCmd: Integer): THandle;
var
  zFileName, zParams, zDir: array[0..79] of Char;
begin
  Result := ShellExecute(Application.MainForm.Handle, nil,
    StrPCopy(zFileName, FileName), StrPCopy(zParams, Params),
    StrPCopy(zDir, DefaultDir), ShowCmd);
end;


Procedure mywinexec(progname : string; SHOWMODE : integer);
Var
   winerr : integer;
   estr : pchar;

begin
   estr := stralloc(255);
   strpcopy(estr, progname);
   winerr := winexec(estr, SHOWMODE);
   if (winerr < 32) then case winerr of
0 :	showmessage('System was out of memory, executable file was corrupt, or relocations were invalid.');
2 :	showmessage('	File was not found.');
3 :	showmessage('	Path was not found.');
5 :	showmessage('	Attempt was made to dynamically link to a task,'
                   +' or there was a sharing or network-protection error.');
6 :	showmessage('	Library required separate data segments for each task.');
8 :	showmessage('	There was insufficient memory to start the application.');
10 :	showmessage('	Windows version was incorrect.');
11 :	showmessage('	Executable file was invalid. Either it was not a Windows'
                   +' application or there was an error in the .EXE image.');
12 :	showmessage('	Application was designed for a different operating system.');
13 :	showmessage('	Application was designed for MS-DOS 4.0.');
14 :	showmessage('	Type of executable file was unknown.');
15 :	showmessage('	Attempt was made to load a real-mode application (developed for'
                   +' an earlier version of Windows).');
16 :	showmessage('	Attempt was made to load a second instance of an executable'
                   +' file containing multiple data segments that were not marked read-only.');
19 :	showmessage('	Attempt was made to load a compressed executable file. The '
                   +' file must be decompressed before it can be loaded.');
20 :	showmessage('	Dynamic-link library (DLL) file was invalid. One of the DLLs '
                   +' required to run this application was corrupt.');
21 :	showmessage('	Application requires 32-bit extensions.');
           end
           else begin
{             repeat
               application.processmessages;
               done := application.terminated or (getmoduleUsage(winerr) = 0);
             until done;}

           end;
   strdispose(estr);
end;

function extreal(re : tfloat) : string;

var
 estr,tstr : string;
 epos,endpos : byte;

function do_exp(expstr : string; var leng : byte) : string;
var
  bg,num,lc,exppos : byte;
  testr : string;

begin
  num := 2;
  exppos := pos('E',expstr);
  bg := num + exppos;
  testr := copy(expstr,exppos,num);
  exppos := length(expstr);
  for lc := bg to exppos do if (expstr[lc] <> '0') then begin
    testr := testr + expstr[lc];
    inc(num);
  end;
  result := testr;
  leng := num;
end;

begin
  str(re,tstr);
  estr := do_exp(tstr,endpos);
  epos :=  8 - endpos;
  result := concat(copy(tstr,1,epos),estr);
end;

function realstr(z : tfloat) : string;

var
 temp : string;

begin
  if ((z <> 0.0) and ((abs(z) > 1e5) or (abs(z) < 1e-5))) then realstr := extreal(z)
  else begin
   str(z:8:2,temp);
   result := erase_white_begin(temp);
{   result := temp;}
  end;
end;

function str_real(st : string) : tfloat;

var
  t_r : tfloat;
  ecode : integer;

begin
  val(st,t_r,ecode);
  if (ecode = 0) then result := t_r
		 else result := 0.0;
end;

function extractdate(dte : string) : tdatetime;

var
  ecode : integer;
  dum : array[0..3] of word;
  lc,sl_1 : word;

begin
  fillchar(dum, sizeof(dum), #0);
  result := now;
  for lc := 1 to 3 do begin
   sl_1 := pos('/',dte);
   if (sl_1 = 0) then begin
     if (lc = 3) then begin
       val(dte, dum[1], ecode);
     end
     else dum[4-lc] := 0
   end
   else begin
     val(copy(dte,1,pred(sl_1)),dum[4-lc],ecode);
     if (ecode <> 0) then dum[4-lc] := 0;
     delete(dte,1,sl_1);
    end;
  end;
  try
    if dum[1] < 1900 then inc(dum[1], 1900);
    result := encodedate( dum[1], dum[2], dum[3]);
  except
  end;
end;

function MySelectDirectory(Caption, Root: string; var Directory: string): Boolean;
var
  BrowseInfo: TBrowseInfo;
  Buffer: PChar;
  RootItemIDList, ItemIDList: PItemIDList;
  ShellMalloc: IMalloc;
  IDesktopFolder: IShellFolder;
  fRoot: WideString;
  Eaten, Flags: LongWord;

begin
  Result := False;
  Directory := '';
  FillChar(BrowseInfo, SizeOf(BrowseInfo), 0);
  froot := root;
  if (ShGetMalloc(ShellMalloc) = S_OK) and (ShellMalloc <> nil) then
  begin
    Buffer := ShellMalloc.Alloc(MAX_PATH);
    try
      SHGetDesktopFolder(IDesktopFolder);
      IDesktopFolder.ParseDisplayName(Application.Handle, nil,
        POleStr(fRoot), Eaten, RootItemIDList, Flags);
      Caption := Caption+#0;
      with BrowseInfo do
      begin
        hwndOwner := Application.Handle;
        pidlRoot := RootItemIDList;
        pszDisplayName := Buffer;
        lpszTitle := @Caption[1];
        ulFlags := BIF_RETURNONLYFSDIRS;
      end;
      ItemIDList := ShBrowseForFolder(BrowseInfo);
      Result :=  ItemIDList <> nil;
      if Result then
      begin
        ShGetPathFromIDList(ItemIDList, Buffer);
        ShellMalloc.Free(ItemIDList);
        Directory := Buffer;
      end;
    finally
      ShellMalloc.Free(Buffer);
    end;
  end;
end;

initialization
  yearoffset := 1900;
  set_today;
end.
















